diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandDamage.java b/src/main/java/net/minecraft/core/net/command/commands/CommandDamage.java
index 2c0c70802..5cc8b2e89 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandDamage.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandDamage.java
@@ -5,6 +5,7 @@ import com.mojang.brigadier.arguments.IntegerArgumentType;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeDamageType;
@@ -13,8 +14,8 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 
 import java.util.List;
 
-public class CommandDamage {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandDamage implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("damage")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entities", ArgumentTypeEntity.entities())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandFill.java b/src/main/java/net/minecraft/core/net/command/commands/CommandFill.java
index c61e6c494..eff487e24 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandFill.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandFill.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeBlock;
 import net.minecraft.core.net.command.arguments.ArgumentTypeIntegerCoordinates;
@@ -17,8 +18,8 @@ import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class CommandFill {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandFill implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("fill")
             .requires(CommandSource::hasAdmin)
             .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("first", ArgumentTypeIntegerCoordinates.intCoordinates())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandGameMode.java b/src/main/java/net/minecraft/core/net/command/commands/CommandGameMode.java
index 5a2aae16d..36f9f5676 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandGameMode.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandGameMode.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.arguments.ArgumentTypeGameMode;
@@ -17,8 +18,8 @@ import net.minecraft.core.player.gamemode.Gamemode;
 
 import java.util.List;
 
-public class CommandGameMode {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandGameMode implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("gamemode")
             .requires(CommandSource::hasAdmin)
             .then(RequiredArgumentBuilder.<CommandSource, Gamemode>argument("gamemode", ArgumentTypeGameMode.gameMode())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandGameRule.java b/src/main/java/net/minecraft/core/net/command/commands/CommandGameRule.java
index f396d100d..32a9f58f0 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandGameRule.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandGameRule.java
@@ -9,23 +9,21 @@ import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRuleBoolean;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeGameruleGeneric;
 import net.minecraft.core.net.packet.GameRulePacket;
-import net.minecraft.server.net.command.ServerCommandSource;
 
-public class CommandGameRule {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandGameRule implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         final LiteralArgumentBuilder<CommandSource> argumentBuilder = LiteralArgumentBuilder.<CommandSource>literal("gamerule").requires(CommandSource::hasAdmin);
         for (final GameRule<?> gameRule : Registries.GAME_RULES) {
             RequiredArgumentBuilder<CommandSource, ?> gameRuleValueArgument;
             if (gameRule instanceof GameRuleBoolean) {
                 gameRuleValueArgument = RequiredArgumentBuilder.<CommandSource, Boolean>argument("value", BoolArgumentType.bool())
                         .executes(c -> {
-                            c.getSource().getWorld().getLevelData().getGameRules().setValue((GameRule<? super Object>) gameRule, BoolArgumentType.getBool(c, "value"));
-                            if (c.getSource() instanceof ServerCommandSource) {
-                                ((ServerCommandSource)c.getSource()).server.playerList.sendPacketToAllPlayers(new GameRulePacket(c.getSource().getWorld().getLevelData().getGameRules()));
-                            }
+                            c.getSource().getWorld().getLevelData().getGameRules().setValue((GameRuleBoolean) gameRule, BoolArgumentType.getBool(c, "value"));
+                            c.getSource().sendPacketToAllPlayers(() -> new GameRulePacket(c.getSource().getWorld().getLevelData().getGameRules()));
                             c.getSource().sendTranslatableMessage("command.commands.gamerule.set", gameRule.getKey(), BoolArgumentType.getBool(c, "value"));
                             return Command.SINGLE_SUCCESS;
                         });
@@ -33,10 +31,8 @@ public class CommandGameRule {
                 gameRuleValueArgument = RequiredArgumentBuilder.<CommandSource, Object>argument("value", ArgumentTypeGameruleGeneric.gameRule(gameRule))
                         .executes(c -> {
                             Object o = c.getArgument("value", Object.class);
-                            c.getSource().getWorld().getLevelData().getGameRules().setValue((GameRule<? super Object>) gameRule, o);
-                            if (c.getSource() instanceof ServerCommandSource) {
-                                ((ServerCommandSource)c.getSource()).server.playerList.sendPacketToAllPlayers(new GameRulePacket(c.getSource().getWorld().getLevelData().getGameRules()));
-                            }
+                            c.getSource().getWorld().getLevelData().getGameRules().setValue((GameRule) gameRule, o);
+                            c.getSource().sendPacketToAllPlayers(() -> new GameRulePacket(c.getSource().getWorld().getLevelData().getGameRules()));
                             c.getSource().sendTranslatableMessage("command.commands.gamerule.set", gameRule.getKey(), o);
                             return Command.SINGLE_SUCCESS;
                         });
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandGive.java b/src/main/java/net/minecraft/core/net/command/commands/CommandGive.java
index 36ded5a31..d924ab645 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandGive.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandGive.java
@@ -8,6 +8,7 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
@@ -16,8 +17,8 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 
 import java.util.List;
 
-public class CommandGive {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandGive implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("give")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", ArgumentTypeEntity.players())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandHeal.java b/src/main/java/net/minecraft/core/net/command/commands/CommandHeal.java
index cbcf96366..917fc4b15 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandHeal.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandHeal.java
@@ -6,6 +6,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.net.command.CommandSource;
@@ -15,8 +16,8 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 import java.lang.reflect.InvocationTargetException;
 import java.util.List;
 
-public class CommandHeal {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandHeal implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("heal")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entities", ArgumentTypeEntity.entities())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandHelp.java b/src/main/java/net/minecraft/core/net/command/commands/CommandHelp.java
index 57a9aa602..bb5d4c20e 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandHelp.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandHelp.java
@@ -8,15 +8,16 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.util.Iterables;
 
 import java.util.Map;
 
-public class CommandHelp {
+public class CommandHelp implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.help.exception_failure"));
 
-    public static void register(CommandDispatcher<CommandSource> commandDispatcher) {
+    public void register(CommandDispatcher<CommandSource> commandDispatcher) {
         commandDispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("help")
             .executes(c -> {
                 CommandSource source = c.getSource();
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandKill.java b/src/main/java/net/minecraft/core/net/command/commands/CommandKill.java
index 96c353d82..7b04917c5 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandKill.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandKill.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
@@ -17,10 +18,10 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 
 import java.util.concurrent.CopyOnWriteArrayList;
 
-public class CommandKill {
+public class CommandKill implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.kill.exception_failure"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("kill")
                 .requires(CommandSource::hasAdmin)
                 .executes(c -> {
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandMessage.java b/src/main/java/net/minecraft/core/net/command/commands/CommandMessage.java
index 04aaea7c3..c7ce6318d 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandMessage.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandMessage.java
@@ -9,6 +9,7 @@ import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
@@ -17,8 +18,8 @@ import net.minecraft.core.util.helper.LoggedPrintStream;
 
 import java.util.List;
 
-public class CommandMessage {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandMessage implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("message")
                 .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("targets", ArgumentTypeEntity.players())
                         .then(RequiredArgumentBuilder.<CommandSource, String>argument("message", StringArgumentType.greedyString())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandMobSpawning.java b/src/main/java/net/minecraft/core/net/command/commands/CommandMobSpawning.java
index bed9bfc2b..85fcf50b8 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandMobSpawning.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandMobSpawning.java
@@ -9,6 +9,7 @@ import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntitySummon;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -17,11 +18,11 @@ import net.minecraft.core.world.config.spawning.SpawnerConfig;
 
 import java.util.Collection;
 
-public class CommandMobSpawning {
+public class CommandMobSpawning implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE =
         new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.mobspawning.exception_failure", arg));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
             (
                 LiteralArgumentBuilder.<CommandSource>literal("mobspawning")
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandPlace.java b/src/main/java/net/minecraft/core/net/command/commands/CommandPlace.java
index b2cd4b023..8548bf1b3 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandPlace.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandPlace.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.WorldFeature;
@@ -16,10 +17,10 @@ import net.minecraft.core.net.command.arguments.ArgumentTypeWorldFeature;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 
-public class CommandPlace {
+public class CommandPlace implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.place.exception_failure"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("place")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, WorldFeature>argument("feature", ArgumentTypeWorldFeature.worldFeature())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandPlaySound.java b/src/main/java/net/minecraft/core/net/command/commands/CommandPlaySound.java
index 4b75031bd..8b79636a6 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandPlaySound.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandPlaySound.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.arguments.ArgumentTypeSoundCategory;
@@ -20,8 +21,8 @@ import net.minecraft.core.world.World;
 
 import java.util.List;
 
-public class CommandPlaySound {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandPlaySound implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
             (
                 LiteralArgumentBuilder.<CommandSource>literal("playsound")
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandSay.java b/src/main/java/net/minecraft/core/net/command/commands/CommandSay.java
index 43be12bb8..0a24af6dd 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandSay.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandSay.java
@@ -5,10 +5,11 @@ import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.arguments.StringArgumentType;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 
-public class CommandSay {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandSay implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("say")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, String>argument("message", StringArgumentType.greedyString())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java b/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
index ee350fbf6..518c295f1 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
@@ -3,10 +3,11 @@ package net.minecraft.core.net.command.commands;
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 
-public class CommandSeed {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandSeed implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("seed")
                 .requires(CommandSource::hasAdmin)
                 .executes(c -> {
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandSetBlock.java b/src/main/java/net/minecraft/core/net/command/commands/CommandSetBlock.java
index 82bdd8af0..45323a052 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandSetBlock.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandSetBlock.java
@@ -6,6 +6,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.world.World;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
@@ -13,10 +14,10 @@ import net.minecraft.core.net.command.arguments.*;
 import net.minecraft.core.net.command.helpers.BlockInput;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 
-public class CommandSetBlock {
+public class CommandSetBlock implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.setblock.exception_failure"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("setblock")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("position", ArgumentTypeIntegerCoordinates.intCoordinates())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandSetSpawn.java b/src/main/java/net/minecraft/core/net/command/commands/CommandSetSpawn.java
index f23f98ea5..7bdb6cf02 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandSetSpawn.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandSetSpawn.java
@@ -5,13 +5,14 @@ import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeIntegerCoordinates;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 
-public class CommandSetSpawn {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandSetSpawn implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("setworldspawn")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("position", ArgumentTypeIntegerCoordinates.intCoordinates())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandSpawn.java b/src/main/java/net/minecraft/core/net/command/commands/CommandSpawn.java
index e89488580..76b0d2754 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandSpawn.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandSpawn.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -17,8 +18,8 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 
 import java.util.List;
 
-public class CommandSpawn {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandSpawn implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("spawn")
                 .requires(CommandSource::hasAdmin)
                 .executes(c -> {
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandSpawnParticle.java b/src/main/java/net/minecraft/core/net/command/commands/CommandSpawnParticle.java
index 6010c839b..49f5ca96a 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandSpawnParticle.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandSpawnParticle.java
@@ -8,6 +8,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.arguments.ArgumentTypeParticleId;
@@ -18,8 +19,8 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 
-public class CommandSpawnParticle {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandSpawnParticle implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
             (
                 LiteralArgumentBuilder.<CommandSource>literal("spawnparticle")
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java b/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
index a2bfccb53..3c8607b28 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.context.CommandContext;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.net.command.util.CommandHelper;
@@ -16,8 +17,8 @@ import net.minecraft.core.net.command.arguments.ArgumentTypeVec3;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.helpers.DoubleCoordinates;
 
-public class CommandSummon {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandSummon implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("summon")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, Class<? extends Entity>>argument("entity", ArgumentTypeEntitySummon.entity())
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java b/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
index 6105e7c01..4d9198b55 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
@@ -6,6 +6,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
@@ -16,8 +17,8 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 
 import java.util.List;
 
-public class CommandTeleport {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandTeleport implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("teleport")
                 .requires(CommandSource::hasAdmin)
                 .then(RequiredArgumentBuilder.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVec3.vec3d())
